<?php
/*
 * Example of using API webhooks
 * sending notifications to Slack
 */


// Sending a notification to Slack - https://api.slack.com/methods/chat.postMessage
function sendSlackMessage($channel, $from, $msg){
	// You can get a token here https://api.slack.com/web
	$token = 'xuxu-8043992880-8270042386-********-63a0c7d0d1';
	
	$curl = curl_init('https://slack.com/api/chat.postMessage');
	curl_setopt_array($curl, array( CURLOPT_RETURNTRANSFER => true, CURLOPT_POST => true,
		CURLOPT_POSTFIELDS => http_build_query(array( 'mrkdwn' => true,
			'token' => $token, 
			'channel' => $channel, 'username' => $from, 'text' => $msg 
		)),
	));
	return json_decode( curl_exec($curl), 1);
}


/*
 * Processing of received data
 */
if (in_array($_REQUEST['event'], array('lead','pay'))) { $br = '
';
	// We form a message to send
	// using the information received about a lead
	$lead = $_REQUEST['data'];

	$pay_statuses = array(
		0 => 'Pending payment',
		1 => 'Payment in process',
		2 => 'Paid',
		3 => 'Payment error',
	);

	/* Title/from */	
	$from = 'New lead No.'.$lead['num'];
	// a different title for payment
	if ($_REQUEST['event']=='pay') { 
		$from = 'Payment of lead No.'.$lead['num'];

		if($lead['pay']['status']['code']!=2){
			$from = 'Problems with paying the invoice for lead No.'.$lead['num'];;
		}

		if($lead['pay']['test']==1){
			$from = 'Test payment of lead No.'.$lead['num'];;
		}
	}
	


	/* Message */
	$msg = '';
	// information about payment
	if ($_REQUEST['event']=='pay') { 
		$msg .= ':moneybag::moneybag::moneybag:'.$br;
		$msg .= '> *Amount*: '.$lead['pay']['summ'].' USD'.$br;
		$msg .= '> *Status*: '.$pay_statuses[ $lead['pay']['status']['code'] ].$br;
		$msg .= '> *Payment method*: '.$lead['pay']['method'].$br;
		$msg .= '> *Comment*: '.$lead['pay']['desc'].$br;
		$msg .= '> Time of creation: '.date('d.m.Y H:i', $lead['pay']['time_create']).$br;
		$msg .= '> Time of payment: '.date('d.m.Y H:i', $lead['pay']['time_done']).$br;
	}


	// Information about a lead
	$msg .= ':raising_hand::skin-tone-2: Lead from the page <'.$lead['page']['url'].'|'.$lead['page']['name'].' ('.$lead['page']['url'].')>'.$br;	
	// Lead fields
	foreach ($lead['form_data'] as $k => $item) {
		$msg .= '          *'.$item['name'].'*: '.$item['value'].$br;
	}
	// Link to payment of invoice
	if($_REQUEST['event']=='lead' && count($lead['pay'])>0){
		$msg .= ':moneybag: Created <'.$lead['pay']['pay_link'].'|invoice for payment>_    ';
	}
	
	// Link to view the lead in the admin panel
	$msg .= ':pencil:  <http://'.$_REQUEST['site']['domain'].'/admin/lead/view/?id='.$lead['id'].'|Go to the lead>';


	// $msg = '```'.print_r($_REQUEST, true).'```'; // debugging
	
	// We send a notification
	sendSlackMessage('#general', $from, $msg);
}

